#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "threadpool4xi.py">
#<abstract4xi abstract = "provides class ThreadPool4Xi"/>
#<refer4xi reference = "pool.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ThreadPool4Xi' ] 
#"
#/>
 


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import time         
except:
    pass
try:                 # rare ones
    import queue                    
    import itertools
    import collections          
except:
    pass 
         
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import Pool
except:
    print("pool4xi.py *** failed in from multiprocessing.pool import Pool ***")
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import constant_family4xi
import constant_heap4xi
import constant_pool4xi
import constant_synchronize4xi
import constant_system4xi
from dummyprocess4xi import DummyProcess4Xi
from pool4xi import Pool4Xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


# =================================================================================================
#<class4xi class = "ThreadPool4Xi" base = "Pool4Xi" child = "None" synopsis = "offers thread pool class" usage = "
#   dummy
#       __init__.py:
#           return ThreadPool(processes, initializer, initargs)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class ThreadPool4Xi(Pool4Xi):
    '''
    offers thread pool class
    '''
                                                                                                                                                                                                                                                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables 
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    Process = DummyProcess4Xi                                # dragonized from dummy import Process
    #"
    #/>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-ThreadPool4Xi" usage = "initializes ThreadPool4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def __init__(self, processes=None, initializer=None, initargs=()):
        '''
        initializes ThreadPool4Xi

        '''
        class2print = "ThreadPool4Xi"
        method2print = "__init__"
    
        message2print = "{started" + "; init-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        message2print = "{borning" + "; threadpool2xi-of-ThreadPool4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        message2print = "{inheriting" + "; Pool4Xi-inheriting-by-threadpool2xi-of-ThreadPool4Xi: " + str(Pool4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        message2print = "{sharing" + "; Process-sharing-by-threadpool2xi-of-ThreadPool4Xi: " + str(ThreadPool4Xi.Process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                                
        message2print = "{passed" + "; processes-passed-to-init-of-ThreadPool4Xi: " + str(processes) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                     
                
        message2print = "{passed" + "; initializer-passed-to-init-of-ThreadPool4Xi: " + str(initializer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                  
                
        message2print = "{passed" + "; initargs-passed-to-init-of-ThreadPool4Xi: " + str(initargs) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                   
                 
                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{passing" + "; processes-passing-to-Pool4Xi-by-init-of-ThreadPool4Xi: " + str(processes) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
        message2print = "{passing" + "; initializer-passing-to-Pool4Xi-by-init-of-ThreadPool4Xi: " + str(initializer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                          
        
        message2print = "{passing" + "; initargs-passing-to-Pool4Xi-by-init-of-ThreadPool4Xi: " + str(initargs) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        Pool4Xi.__init__(self, processes, initializer, initargs)
    

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{activated" + "; threadpool2xi-of-ThreadPool4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        message2print = "{inherited" + "; Pool4Xi-inherited-by-threadpool2xi-of-ThreadPool4Xi: " + str(Pool4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        message2print = "{shared" + "; Process-shared-by-threadpool2xi-of-ThreadPool4Xi: " + str(ThreadPool4Xi.Process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                          
        message2print = "{returning" + "; init-of-ThreadPool4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        

    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "setup-queues-of-ThreadPool4Xi" usage = "setups queues">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def _setup_queues(self):
        '''
        ThreadPool4Xi method _setup_queues: setups queues
        '''
        class2print = "ThreadPool4Xi"
        method2print = "_setup_queues"

        message2print = "{started" + "; setup-queues-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                                     
                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 

        self._inqueue = queue.Queue()
        
        message2print = "{set" + "; inqueue-of-threadpool2xi-set-by-setup-queues-of-ThreadPool4Xi to: " + str(self._inqueue)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
            
        self._outqueue = queue.Queue()
        
        message2print = "{set" + "; outqueue-of-threadpool2xi-set-by-setup-queues-of-ThreadPool4Xi to: " + str(self._outqueue)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        
        self._quick_put = self._inqueue.put
        
        message2print = "{set" + "; quick_put-of-threadpool2xi-set-by-setup-queues-of-ThreadPool4Xi to: " + str(self._quick_put)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
          
        
        self._quick_get = self._outqueue.get
        
        message2print = "{set" + "; quick_get-of-threadpool2xi-set-by-setup-queues-of-ThreadPool4Xi to: " + str(self._quick_get)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{returning" + "; setup-queues-of-ThreadPool4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                  
    #</methodize4xi>
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "help-stuff-finish-of-ThreadPool4Xi" usage = "puts sentinels at head of inqueue to make workers finish">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    @staticmethod
    def _help_stuff_finish(inqueue, task_handler, size):
        '''
        ThreadPool4Xi method _help_stuff_finish: puts sentinels at head of inqueue to make workers finish
        '''
        class2print = "ThreadPool4Xi"
        method2print = "_help_stuff_finish"

        message2print = "{started" + "; help-stuff-finish-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        message2print = "{passed" + "; inqueue-passed-to-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
 
        message2print = "{passed" + "; task-handler-passed-to-help-stuff-finish-of-ThreadPool4Xi: " + str(task_handler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
   
        message2print = "{passed" + "; size-passed-to-help-stuff-finish-of-ThreadPool4Xi: " + str(size) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        # -----------------------------------------------------------------------------------------    
        # PUT SENTINELS AT HEAD OF INQUEUE TO MAKE WORKERS FINISH
        # -----------------------------------------------------------------------------------------                 
        inqueue.not_empty.acquire()

        message2print = "{performed" + "; inqueue-not-empty-acquire-performed-by-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue.not_empty.acquire) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
                
        try:
            inqueue.queue.clear()
            

            message2print = "{performed" + "; inqueue-queue-clear-performed-by-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue.queue.clear) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
               

            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------    
            message2print = "{passing" + "; size-passing-to-inqueue-queue-extend-by-help-stuff-finish-of-ThreadPool4Xi: " + str([None] * size) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                
                            
               
            inqueue.queue.extend([None] * size)
            

            message2print = "{performed" + "; inqueue-queue-extend-performed-by-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue.queue.extend) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
               
          

            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------    
               
            inqueue.not_empty.notify_all()
            

            message2print = "{performed" + "; inqueue-not-empty-notify_all-performed-by-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue.not_empty.notify_all) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
               
               
            
        finally:
            inqueue.not_empty.release()
            

            message2print = "{performed" + "; inqueue-not-empty-release-performed-by-help-stuff-finish-of-ThreadPool4Xi: " + str(inqueue.not_empty.release) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
               
            

            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------    
        
        message2print = "{returning" + "; help-stuff-finish-of-ThreadPool4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                
                
                           
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
 
    #</methodize4xi>
    
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ThreadPool4Xi" usage = "senses ThreadPool4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses ThreadPool4Xi class objects
        '''
        
        
        class2print = 'ThreadPool4Xi'
        method2print = 'sense'
        

        message2print = "{started" + "; sense-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; ThreadPool4Xi-sensing-by-sense-of-ThreadPool4Xi: " + str(ThreadPool4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ThreadPool4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
     
            kb2xi['inqueue-of-threadpool4xi'] = self._inqueue
            kb2xi['outqueue-of-threadpool4xi'] = self._outqueue            
            kb2xi['quick_put-of-threadpool4xi'] = self._quick_put 
            kb2xi['quick_get-of-threadpool4xi'] = self._quick_get
                                
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ThreadPool4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
        
        
        message2print = "{sensed" + "; ThreadPool4Xi-sensed-by-sense-of-ThreadPool4Xi: " + str(ThreadPool4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ThreadPool4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------

    #<methodize4xi method = "reason-of-ThreadPool4Xi" usage = "reasons ThreadPool4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons ThreadPool4Xi class objects
        '''
        
        
        class2print = 'ThreadPool4Xi'
        method2print = 'reason'


        message2print = "{started" + "; reason-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; ThreadPool4Xi-reasoning-by-reason-of-ThreadPool4Xi: " + str(ThreadPool4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ThreadPool4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; ThreadPool4Xi-reasoning-by-reason-of-ThreadPool4Xi: " + str(ThreadPool4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ThreadPool4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ThreadPool4Xi" usage = "aces ThreadPool4Xi class objects">
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces ThreadPool4Xi class objects 
        '''
     
        class2print = 'ThreadPool4Xi'
        method2print = 'ace'
        

        message2print = "{started" + "; ace-of-ThreadPool4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; ThreadPool4Xi-acing-by-ace-of-ThreadPool4Xi: " + str(ThreadPool4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ThreadPool4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; ThreadPool4Xi-acing-by-ace-of-ThreadPool4Xi: " + str(ThreadPool4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ThreadPool4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "

#   test_dummy_process4xi.txt
#   sense-dummy-process4xi.xml
#   reason-dummy-process4xi.xml
#   ace-dummy-process4xi.xml


#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of threadpool4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
